/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2017-02-15 17:18:02 UTC)
 * on 2017-08-09 at 08:26:09 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.oauth2.model;

/**
 * Model definition for Jwk.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google OAuth2 API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Jwk extends com.google.api.client.json.GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Keys> keys;

  static {
    // hack to force ProGuard to consider Keys used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(Keys.class);
  }

  /**
   * @return value or {@code null} for none
   */
  public java.util.List<Keys> getKeys() {
    return keys;
  }

  /**
   * @param keys keys or {@code null} for none
   */
  public Jwk setKeys(java.util.List<Keys> keys) {
    this.keys = keys;
    return this;
  }

  @Override
  public Jwk set(String fieldName, Object value) {
    return (Jwk) super.set(fieldName, value);
  }

  @Override
  public Jwk clone() {
    return (Jwk) super.clone();
  }

  /**
   * Model definition for JwkKeys.
   */
  public static final class Keys extends com.google.api.client.json.GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String alg;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String e;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String kid;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String kty;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String n;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String use;

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getAlg() {
      return alg;
    }

    /**
     * @param alg alg or {@code null} for none
     */
    public Keys setAlg(java.lang.String alg) {
      this.alg = alg;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getE() {
      return e;
    }

    /**
     * @param e e or {@code null} for none
     */
    public Keys setE(java.lang.String e) {
      this.e = e;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getKid() {
      return kid;
    }

    /**
     * @param kid kid or {@code null} for none
     */
    public Keys setKid(java.lang.String kid) {
      this.kid = kid;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getKty() {
      return kty;
    }

    /**
     * @param kty kty or {@code null} for none
     */
    public Keys setKty(java.lang.String kty) {
      this.kty = kty;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getN() {
      return n;
    }

    /**
     * @param n n or {@code null} for none
     */
    public Keys setN(java.lang.String n) {
      this.n = n;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getUse() {
      return use;
    }

    /**
     * @param use use or {@code null} for none
     */
    public Keys setUse(java.lang.String use) {
      this.use = use;
      return this;
    }

    @Override
    public Keys set(String fieldName, Object value) {
      return (Keys) super.set(fieldName, value);
    }

    @Override
    public Keys clone() {
      return (Keys) super.clone();
    }

  }

}
