/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2017-02-15 17:18:02 UTC)
 * on 2017-08-09 at 08:26:09 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.oauth2.model;

/**
 * Model definition for Raw.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google OAuth2 API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Raw extends com.google.api.client.json.GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Keyvalues> keyvalues;

  static {
    // hack to force ProGuard to consider Keyvalues used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(Keyvalues.class);
  }

  /**
   * @return value or {@code null} for none
   */
  public java.util.List<Keyvalues> getKeyvalues() {
    return keyvalues;
  }

  /**
   * @param keyvalues keyvalues or {@code null} for none
   */
  public Raw setKeyvalues(java.util.List<Keyvalues> keyvalues) {
    this.keyvalues = keyvalues;
    return this;
  }

  @Override
  public Raw set(String fieldName, Object value) {
    return (Raw) super.set(fieldName, value);
  }

  @Override
  public Raw clone() {
    return (Raw) super.clone();
  }

  /**
   * Model definition for RawKeyvalues.
   */
  public static final class Keyvalues extends com.google.api.client.json.GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String algorithm;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String exponent;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String keyid;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String modulus;

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getAlgorithm() {
      return algorithm;
    }

    /**
     * @param algorithm algorithm or {@code null} for none
     */
    public Keyvalues setAlgorithm(java.lang.String algorithm) {
      this.algorithm = algorithm;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getExponent() {
      return exponent;
    }

    /**
     * @param exponent exponent or {@code null} for none
     */
    public Keyvalues setExponent(java.lang.String exponent) {
      this.exponent = exponent;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getKeyid() {
      return keyid;
    }

    /**
     * @param keyid keyid or {@code null} for none
     */
    public Keyvalues setKeyid(java.lang.String keyid) {
      this.keyid = keyid;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getModulus() {
      return modulus;
    }

    /**
     * @param modulus modulus or {@code null} for none
     */
    public Keyvalues setModulus(java.lang.String modulus) {
      this.modulus = modulus;
      return this;
    }

    @Override
    public Keyvalues set(String fieldName, Object value) {
      return (Keyvalues) super.set(fieldName, value);
    }

    @Override
    public Keyvalues clone() {
      return (Keyvalues) super.clone();
    }

  }

}
